#define DEBUG

var/Pathfinder/pathfinder[] = list()

mob
	Login()
		src.icon = 'Icons.dmi'
		src.icon_state = "Player"
		src.loc = locate(1,3,1)
		..()

	verb
		WalkToEndPoint()
			WalkTo(5,1)

	proc
		//This is just extra if you want to include diagonal movement for shorter paths
		SimplifyVectors(list/Vector2/path)
			var/list/Vector2/newPath = list()
			for(var/i = 1 to length(path))
				if(i != length(path))
					var/Vector2
						v1 = path[i]
						v2 = path[i + 1]

					// Get the diagonals
					if((v2.x == v1.x + 1 && v2.y == v1.y + 1) /*Northeast*/ || (v2.x == v1.x - 1 && v2.y == v1.y + 1) /*Northwest*/ || (v2.x == v1.x - 1 && v2.y == v1.y - 1) /*Southwest*/ || (v2.x == v1.x + 1 && v2.y == v1.y - 1) /*Southeast*/)
						newPath.Add(v2) // Skip the first one and move diagonally to the next one.
						continue

					newPath.Add(v1)

			return newPath

		WalkTo(_x, _y)
			if(!("[src.z]" in pathfinder))
				pathfinder["[src.z]"] = new/Pathfinder(world.maxx, world.maxy, src.z)

			var/Pathfinder/pf = pathfinder["[src.z]"]
			var/list/Vector2/path = pf.FindPath(new/Point(src.x, src.y), new/Point(_x, _y))
			path = SimplifyVectors(path)

			for(var/Vector2/point in path)
				if(step_towards(src, locate(point.x, point.y, src.z), 0))
					sleep(world.tick_lag * 8) // Slows it down so we can see them move. You typically just want to use world.tick_lag alone or whatever you prefer.
					continue
				else
					//Failed to get to the next spot.
					return